<?php
/***********************************************************/
#a quick script to pull together a visual status page
#by ryan north (ryan@qwantz.com) on jan 2nd 2009
#no warranty express or implied!  dudes i totally just threw this together!!  normally i code better, honest
#you can use this for free under one condition: YOU HAVE TO HIGH FIVE AT LEAST ONE PERSON WITHIN THE NEXT 10 MINUTES!!!  HOLY COW THE CLOCK IS TICKING
/***********************************************************/

#okay to use this you'll need a \backgrounds directory beneath wherever this script is run, where you can drop in some fancy backgrounds.  if they're not jpg, png or gif, bad stuff might happen
#as well, chart1.png, chart2.png, chart3.png are hard-coded in.  replace these with whatever you want, or with a file grabbed off a webserver, which is what i did!
#you'll also need some ttf fonts: in this code, i assume font1.ttf and font2.ttf but they could be ANYTHANG

#where our final images should go
$outputpath = 'c:\\frametimesareawesometimes\\';

#and how big they should be
$width = 480;
$height = 800;

#the filenames of the chart images we want to include
$file1 = 'chart1.png';
$file2 = 'chart2.png';
$file3 = 'chart3.png';

#get size of these files
$s1 = getimagesize($file1);
$s2 = getimagesize($file2);
$s3 = getimagesize($file3);

#and load them into memory
$src1 = imagecreatefrompng($file1);
$src2 = imagecreatefrompng($file2);
$src3 = imagecreatefrompng($file3);

#how small are we making these images?
$h = $height /4;

#we are going to shrink our charts down so they fit the width across, so how tall will they be?
$percent1 = ($width)/ $s1[0];
$percent2 = ($width)/ $s2[0];
$percent3 = ($width)/ $s3[0];

#get this expressed as a percentage of the height
$hp1 = $h * $percent1;
$hp2 = $h * $percent2;
$hp3 = $h * $percent3;

#now create new images that are this height that we want
$dest1 = imagecreatetruecolor($width, $hp1);
$dest2 = imagecreatetruecolor($width, $hp2);
$dest3 = imagecreatetruecolor($width, $hp3);

#our chart files have things like a scale and a title on them.  let's just grab the visually interesting part here, which is the actual chart.
#the magic numbers below are trial and error numbers for the charts i'm generating to only grab the good parts - if you just want to drop an image in without modification, then you can replace them all with 0s
imagecopyresampled($dest1, $src1, 0, 0, 58, 29, $width+37, $hp1, $s1[0]-19, $s1[1]-55-36);
imagecopyresampled($dest2, $src2, 0, 0, 58, 29, $width+37, $hp2, $s1[0]-19, $s1[1]-55-36);
imagecopyresampled($dest3, $src3, 0, 0, 58, 29, $width+37, $hp2, $s1[0]-19, $s1[1]-55-36);

#drop stuff we no longer need
imagedestroy($src1);
imagedestroy($src2);
imagedestroy($src3);

#now build our final canvas of the width and height we specified
$final = imagecreatetruecolor($width, $height);

#put on our background randomly - first, find any file in our directory (gif, jpg or png only - anything else will crash this script)
$files = array();
if ($handle = opendir('backgrounds')) {
	while (false !== ($file = readdir($handle))) {
		if ($file != "." && $file != "..") {
			array_push($files, $file);
		}    
	}
}
#get a random index of all these files
$i = (rand() % sizeof($files));

#grab the name of this random background image
$bg = $files[$i];
#and figure out how big it is
$bs = getimagesize('backgrounds\\' . $bg);

#figure out its file extension
$ext = explode('.',$bg);
$ext = $ext[count($ext)-1];
$ext = strtolower($ext);

#and open it
if ($ext=='gif'){
	$bg = imagecreatefromgif('backgrounds\\' . $bg);
}elseif ($ext=='png'){
	$bg = imagecreatefrompng('backgrounds\\' . $bg);
}else{
	$bg = imagecreatefromjpeg('backgrounds\\' . $bg);
}

#place the bg on the image
imagecopymerge($final, $bg, 0, 0, 0, 0, $bs[0], $bs[1], 100);

#now place the rest of our elements

$headerspace = 130;
$spacing=10;

#the project wonderful logo
$logo = imagecreatefromgif('logo.gif');
$ls = getimagesize('logo.gif');
imagecopymerge($final, $logo, 5, 10, 0, 0, $ls[0], $ls[1], 100);

#our three charts at 95% opacity, so we can see a bit of the background through them
imagecopymerge($final, $dest1, 0, $headerspace, 0, 0, $width, $hp1, 95);
imagecopymerge($final, $dest2, 0, $hp1 + $headerspace + $spacing, 0, 0, $width, $hp2, 95);
imagecopymerge($final, $dest3, 0, $hp1 + $headerspace + $spacing + $hp2 + $spacing, 0, 0, $width, $hp3, 95);

#add on our logo text
addText($final, "PROJECT", 120, 48, 26, 'font2.ttf');
addText($final, "wonderful", 118, 95, 63);

#now add on our status text - in real life you'd grab this off a website too, rather than hard-coding it in
addText($final, "Happy dudes:", 70, 610);
addText($final, '3000', 300, 610);

addText($final, "Overjoyed dudes:", 70, 655);
addText($final,  '4000', 300, 655);

addText($final, "Blissful dudes:", 70, 700);
addText($final, '6000', 300, 700);

addText($final, "Really sad dudes:", 70, 745);
addText($final, '0', 300, 745);

#get the time 
$t = strtotime("now");
$t = date('D, M jS \a\t g:i:s a', $t);

addText($final, "as of " . $t, 125, 790, 14);

#now save the image twice.  our frame only reads jpeg, but we don't like our status to look terrible, so we encode at 100% quality.
imagejpeg($final, $outputpath . 'status1.jpg', 100);
imagejpeg($final, $outputpath . 'status2.jpg', 100);

#and display it (this bit can be removed if you're not running this script in a browser)
header('Content-Type: image/jpeg');
imagejpeg($final, NULL, 100);


#finally, free up any memory
imagedestroy($dest1);
imagedestroy($dest2);
imagedestroy($dest3);
imagedestroy($final);

#done!
exit;

function addText(&$final, $text, $x, $y, $size = 20, $font='font1.ttf'){
	
	#make some nice shadowed text, from the imagettftext php docs
	$white = imagecolorallocate($final, 255, 255, 255);
	$grey = imagecolorallocate($final, 128, 128, 128);
	$black = imagecolorallocate($final, 0, 0, 0);

	imagettftext($final, $size, 0, $x+2, $y+2, $black, $font, $text);
	imagettftext($final, $size, 0, $x+1, $y+1, $grey, $font, $text);
	imagettftext($final, $size, 0, $x, $y, $white, $font, $text);
	
	imagecolordeallocate($final, $white);
	imagecolordeallocate($final, $grey);
	imagecolordeallocate($final, $black);
}



?>